#version 430
#extension GL_ARB_separate_shader_objects : enable










struct SComputeInput
{
	uvec3 GlobalThreadID; uvec3 LocalThreadID; uvec3 GroupID;};

layout( std140) uniform UData
{
	vec2 TexelSize;
} Data;
 uniform sampler2D InputTexture;
 uniform writeonly image2D OutputTexture;



void ComputeMain( in SComputeInput  cInput  )
{
	vec2 texelSize =  Data.TexelSize ;
	vec2 texCoords = ( vec2(cInput.GlobalThreadID.xy)  + vec2(0.5, 0.5)) * texelSize;
	if (texCoords.x >= 1.0 || texCoords.y >= 1.0) return;

	vec4 col =  textureLod(InputTexture, texCoords, 0) ;
	imageStore(OutputTexture, ivec2(cInput.GlobalThreadID.xy), col) ;
}


layout(local_size_x = 32, local_size_y = 32, local_size_z = 1) in;
void main()
{
	SComputeInput cInput;
	cInput.GlobalThreadID = gl_GlobalInvocationID;
	cInput.LocalThreadID = gl_LocalInvocationID;
	cInput.GroupID = gl_WorkGroupID;
	ComputeMain(cInput);
}
